%define name mpich
%define version 1.2.2.2
%define release 4mdk
%define lib_name_orig libmpich
%define lib_major 0
%define lib_name %{lib_name_orig}%{lib_major}



Name: %{name}
Summary: MPICH is a portable implementation of MPI.
Version: %{version}
Release: %{release}
Source0: %{name}-%{version}.tar.bz2
Patch0: %{name}-1.2.2.2-sysconfdir.patch.bz2
Patch1: %{name}-1.2.2.2-datadir.patch.bz2
URL: http://www-unix.mcs.anl.gov/mpi/mpich/
License: Distributable 
Group: Development/Other
BuildRoot: %{_tmppath}/%{name}-root
Prefix: %{_prefix}

%description
MPICH is a freely available, portable implementation of MPI, the Standard 
for message-passing libraries.
MPICH-A Portable Implementation of MPI is a MPI Standard conforming library 
that was developed by the Argonne National Laboratory. It allows different 
processes across a network of workstations to communicate using specific 
message passing functions. It includes librairies, parallel debuging tools 
and docs.

This package provides the libraries that use the standard p4 device.

%package -n mpich-doc
Summary: Documentation for developing programs that will use MPICH
Group: Development/Other
Requires: mpich = %{version}-%{release}

%description -n mpich-doc
MPICH is a freely available, portable implementation of MPI, the Standard 
for message-passing libraries.
MPICH-A Portable Implementation of MPI is a MPI Standard conforming library 
that was developed by the Argonne National Laboratory. It allows different 
processes across a network of workstations to communicate using specific 
message passing functions. It includes librairies, parallel debuging tools 
and docs.

This package provides the documentation needed to develop
applications using the MPICH libraries.

%package -n %{lib_name}-devel
Summary: Headers for developing programs that will use MPICH
Group: Development/Other
Requires: mpich = %{version}-%{release}

%description -n %{lib_name}-devel
MPICH is a freely available, portable implementation of MPI, the Standard 
for message-passing libraries.
MPICH-A Portable Implementation of MPI is a MPI Standard conforming library 
that was developed by the Argonne National Laboratory. It allows different 
processes across a network of workstations to communicate using specific 
message passing functions. It includes librairies, parallel debuging tools 
and docs.

This package provides the static libraries and header files needed to compile
applications using the MPICH libraries.

%package -n mpicc
Summary: The MPICH wrapper over the C compiler
Group: Development/C
Requires: gcc, %{lib_name}-devel = %{version}-%{release}

%description -n mpicc
MPICH is a freely available, portable implementation of MPI, the Standard 
for message-passing libraries.
MPICH-A Portable Implementation of MPI is a MPI Standard conforming library 
that was developed by the Argonne National Laboratory. It allows different 
processes across a network of workstations to communicate using specific 
message passing functions. It includes librairies, parallel debuging tools 
and docs.

This package provides the shell script mpicc, with headers, which allows to
compile C programs using the MPICH libraries.

%package -n mpic++
Summary: The MPICH wrapper over the C++ compiler
Group: Development/C++
Requires: gcc-c++, %{lib_name}-devel = %{version}-%{release}

%description -n mpic++
MPICH is a freely available, portable implementation of MPI, the Standard 
for message-passing libraries.
MPICH-A Portable Implementation of MPI is a MPI Standard conforming library 
that was developed by the Argonne National Laboratory. It allows different 
processes across a network of workstations to communicate using specific 
message passing functions. It includes librairies, parallel debuging tools 
and docs.

This package provides the shell script mpiCC, with headers, which allows to
compile C++ programs using the MPICH libraries.

%package -n mpif77
Summary: The MPICH wrapper over the Fortran 77 compiler
Group: Development/Other
Requires: gcc-g77, %{lib_name}-devel = %{version}-%{release}

%description -n mpif77
MPICH is a freely available, portable implementation of MPI, the Standard 
for message-passing libraries.
MPICH-A Portable Implementation of MPI is a MPI Standard conforming library 
that was developed by the Argonne National Laboratory. It allows different 
processes across a network of workstations to communicate using specific 
message passing functions. It includes librairies, parallel debuging tools 
and docs.

This package provides the shell script mpif77, with headers, which allows to
compile Fortran 77 (NOT Fortran 90!) programs using the MPICH libraries.


%prep
rm -rf $RPM_BUILD_ROOT
%setup -q
%patch0 -p1 -b .sysconfdir
%patch1 -p1 -b .datadir

find -name .cvsignore | xargs rm -rf
find -name CVS -type d | xargs rm -rf


%build
CFLAGS=$RPM_OPT_FLAGS; export CFLAGS;
[ -f configure.in ] && libtoolize --copy --force;
./configure --prefix=%{_prefix} \
        --exec-prefix=%{_exec_prefix} \
        --bindir=%{_bindir} \
	--sbindir=%{_sbindir} \
        --datadir=%{_datadir}/mpich/ \
        --includedir=%{_includedir} \
	--libdir=%{_libdir} \
        --sharedstatedir=%{_sharedstatedir} \
        --mandir=%{_mandir}
make

%install
%makeinstall PREFIX=$RPM_BUILD_ROOT%{_prefix} \
	     MPIINSTALL_OPTS="-manpath=$RPM_BUILD_ROOT/%{_mandir} -sysconfpath=$RPM_BUILD_ROOT/%{_sysconfdir}/mpich/ -datapath=$RPM_BUILD_ROOT/%{_datadir}/mpich/"

proot="$HOME/rpm/tmp/mpich-root" 
lrep="$proot/etc/mpich $proot/usr/bin $proot/usr/examples $proot/usr/sbin"

for rep in $lrep
do
  for file in $rep/*
  do
	if [ -f "$file" ];
	then
		perl -pi -e 's|%buildroot||g' "$file"
	fi
  done
done

find $RPM_BUILD_ROOT -name CVS -type d | xargs rm -rf

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,755)
%doc COPYRIGHT
%{_sbindir}/*
%{_bindir}/mpirun*
%{_bindir}/mpereconfig
%{_bindir}/mpereconfig.dat
%{_bindir}/mpereconfig.in
%{_bindir}/mpiman
%{_bindir}/mpireconfig
%{_bindir}/mpireconfig.dat
%{_bindir}/tarch
%{_bindir}/tdevice
%{_bindir}/serv_p4
%{_bindir}/clog2alog
%{_bindir}/clog2slog
%{_bindir}/clog_print
%{_bindir}/slog_print
%{_bindir}/logviewer
%dir %{_sysconfdir}/mpich/
%config(noreplace) %{_sysconfdir}/mpich/*

%files -n mpich-doc
%defattr(-,root,root,755)
%doc doc/* examples www

%files -n %{lib_name}-devel
%defattr(-,root,root)
%doc COPYRIGHT
%{_mandir}/man1/*.1*
%{_mandir}/man3/*.3*
%{_mandir}/man4/*.4*
%dir %{_includedir}/mpi2c++
%{_includedir}/mpi2c++/*.h
%{_includedir}/*.h
%{_libdir}/*.a
%{_libdir}/*.o
%dir %{_datadir}/mpich/
%{_datadir}/mpich/*

%files -n mpicc
%defattr(-,root,root,755)
%doc COPYRIGHT
%{_bindir}/mpicc

%files -n mpic++
%defattr(-,root,root,755)
%doc COPYRIGHT
%{_bindir}/mpiCC

%files -n mpif77
%defattr(-,root,root,755)
%doc COPYRIGHT
%{_bindir}/mpif77

%changelog
* Fri Nov 23 2001 Ludovic Francois <lfrancois@mandrakesoft.com> 1.2.2.2-4mdk
- Removed unresolved dependencies

* Mon Nov 19 2001 Ludovic Francois <lfrancois@mandrakesoft.com> 1.2.2.2-3mdk
- Added sub packages mpich-doc mpicc mpic++ mpif77

* Tue Oct 25 2001 Ludovic Francois <lfrancois@mandrakesoft.com> 1.2.2.2-2mdk
- Rebuild for rpmlint

* Fri Oct 12 2001 Ludovic Francois <lfrancois@mandrakesoft.com> 1.2.2.2-1mdk
- Mpich package build for the first time.

# end of file
